<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995-7 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>4.1.1 Array Initialization</title>
<link href="sx4a.html" rev=precedes>
<link href="sx4ba.html" rel=precedes>
<link href="sx4a.html" rev=subdocument>
</head>
<body>
<H3>4.1.1 Array Initialization</H3>

<p>Although it is not possible
to assign to all elements of an array at once
using an assignment expression,
it is possible to initialize some or all elements of an array
when the array is defined.
The syntax looks like this:
<pre>
	int a[10] = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9};
</pre>
The list of values,
enclosed in braces <TT>{}</TT>,
separated by commas,
provides the initial values for successive elements of the array.
</p><p>(Under older, pre-ANSI C compilers,
you could not always supply initializers for
``local'' arrays inside functions;
you could only initialize ``global'' arrays,
those outside of any function.
Those compilers are now rare,
so you shouldn't have to worry about this distinction any more.
We'll talk more about local and global variables
later in this chapter.)
</p><p>If there are fewer initializers than elements in the array,
the remaining elements are automatically initialized to 0.
For example,
<pre>
	int a[10] = {0, 1, 2, 3, 4, 5, 6};
</pre>
would initialize <TT>a[7]</TT>, <TT>a[8]</TT>, and <TT>a[9]</TT> to 0.
When an array definition includes an initializer,
the array dimension may be omitted,
and the compiler will infer the dimension
from the number of initializers.
For example,
<pre>
	int b[] = {10, 11, 12, 13, 14};
</pre>
would declare, define, and initialize
an array <TT>b</TT> of 5 elements
(i.e. just as if you'd typed <TT>int b[5]</TT>).
Only the dimension is omitted;
the brackets <TT>[]</TT> remain
to indicate that <TT>b</TT> is in fact an array.
</p><p>In the case of arrays of <TT>char</TT>,
the initializer may be a string constant:
<pre>
	char s1[7] = "Hello,";
	char s2[10] = "there,";
	char s3[] = "world!";
</pre>

As before,
if
the dimension is omitted,
it is inferred from the size of the string initializer.
(We haven't covered strings in detail yet--we'll
do so in chapter 8--but
it turns out that all strings in C
are terminated by a
special character with the value 0.
Therefore, the array <TT>s3</TT> will be of size 7,
and the explicitly-sized <TT>s1</TT>
does need to be of size at least 7.
For <TT>s2</TT>, the last 4 characters in the array
will all end up being this zero-value character.)
</p><hr>
<p>
Read sequentially:
<a href="sx4a.html" rev=precedes>prev</a>
<a href="sx4ba.html" rel=precedes>next</a>
<a href="sx4a.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995-1997
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
